<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetEcoScoreReportItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetEcoScoreReportItem_V2 extends AbstractStructArrayBase
{
    /**
     * The GetEcoScoreReportItem_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetEcoScoreReportItem_V2[]
     */
    public $GetEcoScoreReportItem_V2;
    /**
     * Constructor method for ArrayOfGetEcoScoreReportItem_V2
     * @uses ArrayOfGetEcoScoreReportItem_V2::setGetEcoScoreReportItem_V2()
     * @param \StructType\GetEcoScoreReportItem_V2[] $getEcoScoreReportItem_V2
     */
    public function __construct(array $getEcoScoreReportItem_V2 = array())
    {
        $this
            ->setGetEcoScoreReportItem_V2($getEcoScoreReportItem_V2);
    }
    /**
     * Get GetEcoScoreReportItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetEcoScoreReportItem_V2[]|null
     */
    public function getGetEcoScoreReportItem_V2()
    {
        return isset($this->GetEcoScoreReportItem_V2) ? $this->GetEcoScoreReportItem_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetEcoScoreReportItem_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetEcoScoreReportItem_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetEcoScoreReportItem_V2ForArrayConstraintsFromSetGetEcoScoreReportItem_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item instanceof \StructType\GetEcoScoreReportItem_V2) {
                $invalidValues[] = is_object($arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item) ? get_class($arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item) : sprintf('%s(%s)', gettype($arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item), var_export($arrayOfGetEcoScoreReportItem_V2GetEcoScoreReportItem_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetEcoScoreReportItem_V2 property can only contain items of type \StructType\GetEcoScoreReportItem_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetEcoScoreReportItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetEcoScoreReportItem_V2[] $getEcoScoreReportItem_V2
     * @return \ArrayType\ArrayOfGetEcoScoreReportItem_V2
     */
    public function setGetEcoScoreReportItem_V2(array $getEcoScoreReportItem_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($getEcoScoreReportItem_V2ArrayErrorMessage = self::validateGetEcoScoreReportItem_V2ForArrayConstraintsFromSetGetEcoScoreReportItem_V2($getEcoScoreReportItem_V2))) {
            throw new \InvalidArgumentException($getEcoScoreReportItem_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($getEcoScoreReportItem_V2) || (is_array($getEcoScoreReportItem_V2) && empty($getEcoScoreReportItem_V2))) {
            unset($this->GetEcoScoreReportItem_V2);
        } else {
            $this->GetEcoScoreReportItem_V2 = $getEcoScoreReportItem_V2;
        }
        return $this;
    }
    /**
     * Add item to GetEcoScoreReportItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\GetEcoScoreReportItem_V2 $item
     * @return \ArrayType\ArrayOfGetEcoScoreReportItem_V2
     */
    public function addToGetEcoScoreReportItem_V2(\StructType\GetEcoScoreReportItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetEcoScoreReportItem_V2) {
            throw new \InvalidArgumentException(sprintf('The GetEcoScoreReportItem_V2 property can only contain items of type \StructType\GetEcoScoreReportItem_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetEcoScoreReportItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetEcoScoreReportItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetEcoScoreReportItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetEcoScoreReportItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetEcoScoreReportItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetEcoScoreReportItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetEcoScoreReportItem_V2
     */
    public function getAttributeName()
    {
        return 'GetEcoScoreReportItem_V2';
    }
}
